#include "ShieldComponent.h"

float ShieldComponent::kMaxLevel = 100.0f;


ShieldComponent::ShieldComponent(int level) 
	: m_level ((float)level)
	, m_recovery(1)
{
}

void ShieldComponent::Update(float deltaTime)
{
	m_level += m_recovery * deltaTime;
	if (m_level > kMaxLevel)
		m_level = kMaxLevel;
}

int ShieldComponent::Damage(int damage)
{
	m_level -= damage;
	if (m_level < 0)
	{
		const int leftOverDamage = (int)-m_level;
		m_level = 0;
		return leftOverDamage;
	}
		
	return 0;
}

int ShieldComponent::GetLevel() const
{
	return (int)m_level;
}



void ShieldComponent::SetRecoveryRate(float rate)
{
	m_recovery = rate;
}










//-----------------------------------


/*
void ShieldComponent::Update(float deltaTime)
{
	const float remainingStep = deltaTime - m_timeUntilRecovery;
	m_timeUntilRecovery -= deltaTime;
	if (m_timeUntilRecovery >= 0)
		return;

	m_level += m_recoveryRate * remainingStep;
	if (m_level > kMaxLevel)
		m_level = kMaxLevel;
}

int ShieldComponent::Damage(int damage)
{
	m_timeUntilRecovery = 2.0f;
	m_level -= damage;
	if (m_level < 0)
	{
		const int leftOverDamage = (int)-m_level;
		m_level = 0;
		return leftOverDamage;
	}
		
	return 0;
}

void ShieldComponent::SetRecoveryRate(float unitsPerSecond)
{
	m_recoveryRate = unitsPerSecond;
}
*/