#include <UnitTest++.h>
#include "Character.h"
#include "ShieldComponent.h"
#include "HealthComponent.h"


namespace {

TEST (StartsWithMaxShield)
{	
	Character character;
	CHECK_EQUAL (ShieldComponent::kMaxLevel, character.GetShieldLevel());
}

TEST (StartsWithMaxHealth)
{	
	Character character;
	CHECK_EQUAL (HealthComponent::kMaxHealth, character.GetHealth());
}

TEST (DamageIsPassedToShieldFirst)
{
	Character character;
	character.Damage(10);
	CHECK_EQUAL (ShieldComponent::kMaxLevel - 10, character.GetShieldLevel());
}

TEST (DamageIsAppliedToHealthAfterShieldIsDepleted)
{
	Character character;
	character.Damage(ShieldComponent::kMaxLevel + 20);
	CHECK_EQUAL (HealthComponent::kMaxHealth - 20, character.GetHealth());
}


}
