#include <UnitTest++.h>
#include "HealthComponent.h"


namespace {

TEST (DefaultHealthComponentStartsAtInitialHealth)
{
	HealthComponent health(100);
	CHECK_EQUAL (100, health.GetAmount());
}

TEST (DamageLowersHealth)
{
	HealthComponent health(100);
	health.Damage(30);
	CHECK_EQUAL (70, health.GetAmount());
}

TEST (DamageDoesNotLowerHealthLowerThanZero)
{
	HealthComponent health(100);
	health.Damage(300);
	CHECK_EQUAL (0, health.GetAmount());
}

TEST (AddingHealthIncreasesAmount)
{
	HealthComponent health(50);
	health.Add(20);
	CHECK_EQUAL (70, health.GetAmount());
}

TEST (AddingHealthDoesNotGoOverMaxAmount)
{
	HealthComponent health(50);
	health.Add(200);
	CHECK_EQUAL (HealthComponent::kMaxHealth, health.GetAmount());
}


}
